diff -d -u -r kibble/kb.c kibble-0.7.2/kb.c
--- kibble/kb.c	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/kb.c	Mon Mar  8 17:56:44 1999
@@ -1,5 +1,5 @@
 /* kb.c
- * $Id: kb.c,v 0.7 1998/12/07 08:07:53 joseph Exp $
+ * $Id: kb.c,v 0.11 1999/02/05 05:49:39 joseph Exp $
  */
 
 /* kibble
@@ -24,7 +24,6 @@
 
 /* Stores the actual KB. Woo hoo, global! */
 GtkWidget *tree_kb;
-GtkObject *current_tree_item=NULL;	/* Currently selected item */
 
 /* Creates a new root node. Assumes that tree_kb's item has already been
  * deleted. */
@@ -33,18 +32,18 @@
         node            *node_ptr;
 
 	/* Create a root node */
-	kb_item = gtk_tree_item_new_with_label (g_string (KB root));
+	kb_item = gtk_tree_item_new_with_label ("KB root");
+        debug_msg("new root node created = 0x%x\n" _ (gint)kb_item);
 
 	node_ptr = new_node ();
-	g_string_assign (node_ptr -> name, g_string (KB root));
+	(void) g_string_assign (node_ptr -> name, "KB root");
 	gtk_object_set_data (GTK_OBJECT (kb_item), "node",
 			(gpointer)node_ptr);
 	gtk_tree_append (GTK_TREE (tree_kb), kb_item);
 	gtk_widget_show (kb_item);
-	gtk_signal_connect (GTK_OBJECT (kb_item),
-			"button_press_event",
-			GTK_SIGNAL_FUNC (on_tree_item_click),
-			NULL);
+	(void) gtk_signal_connect (GTK_OBJECT (kb_item),
+				   "button_press_event", GTK_SIGNAL_FUNC
+				   (on_tree_item_click), NULL);
 }
 
 /* Perhaps more error-checking could be done or more lenient rules
@@ -54,131 +53,152 @@
  * Some of this function may be redundant, but oh well.
  * I should check this for bugs more thoroughly, but it seems to work. */
 void read_kbfile(void){
-	gchar		kbfile[MAX_STR_LEN];
+	gchar		*kbfile;
 	FILE		*ptr;
 	gint		ret;
 
-	/* Is it correct to weight by sizeof (gchar)? */
-	strncpy (kbfile, getenv("HOME"), sizeof (gchar) * (MAX_STR_LEN - 10));
-	strcat  (kbfile, KBFILE);
+        debug_msg("reading kb file\n");
 
+	kbfile = g_strconcat (g_get_home_dir (), KBFILE, NULL);
+
+        debug_msg("opening %s\n" _ kbfile);
 	ptr = fopen (kbfile, "rt");
-	if (!ptr){
+	free (kbfile);
+	if (ptr == NULL){
+		debug_msg("unsuccessful file open\n");
 		new_root_node();
 	} else {
-		fscanf (ptr, "%d", &ret);
-		fgetc (ptr);	/* Read ONE newline */
+		debug_msg("successful file open\n");
+		(void) fscanf	(ptr, "%d", &ret);
+		(void) fgetc	(ptr);	/* Read ONE newline */
 		/* Start at depth 0, hopefully. */
-		g_assert (!ret);
+		g_assert (ret == 0);
 		ret = read_tree_items(0, tree_kb, ptr);
 		g_assert(ret == -1);
 	}
 }
 
-/* Given that we are at tree depth "depth", chidren of "subtree", read
+/* Given that we are at tree depth "depth", children of "subtree", read
    tree items from "ptr" */
 gint read_tree_items (gint depth, GtkWidget *subtree, FILE *ptr){
 	gint		indent, desc_len, ret;
-	gchar		tmpstr[MAX_DESC_LEN];
+	gchar		*tmpstr;
 	node		*node_ptr;
 	GtkWidget	*kb_item = NULL, *new_subtree;
 
+	debug_msg("reading at depth %d\n" _ depth);
+
 	/* We assume the indentation has already been read. */
 	ret = depth;
-	while (!feof (ptr)){
+	tmpstr = g_malloc (sizeof (gchar) * MAX_STR_LEN);
+	while (feof (ptr) == 0){
 		/* If we have not already read the indentation (at a
-		   higher depth) */
+		 * higher depth) */
 		if(ret == -1){
-			fscanf (ptr, "%d", &indent);
-			fgetc (ptr);	/* Read ONE newline */
+			(void) fscanf	(ptr, "%d", &indent);
+			(void) fgetc	(ptr);	/* Read ONE newline */
 			g_assert (indent <= depth+1);
 		} else {
 			indent = ret;
 			ret = -1;
 		}
+		debug_msg("reading at indent %d\n" _ indent);
 		g_assert(indent < MAX_TREE_DEPTH);
 		/* If proper indentation, read the node and put it in
-		   the tree */
+		 * the tree */
 		if (indent == depth){
+			debug_msg ("reading the node\n");
 			node_ptr = new_node ();
 
 			/* Get the name */
-			fgets (tmpstr, MAX_STR_LEN, ptr);
+			(void) fgets (tmpstr, MAX_STR_LEN, ptr);
 			/* Overwrite the final newline with NULL. */
-			tmpstr[strlen (tmpstr) - 1] = 0;
-			g_string_assign (node_ptr -> name, tmpstr);
+			tmpstr = g_strchomp (tmpstr);
+			(void) g_string_assign (node_ptr -> name, tmpstr);
 
 			/* Get the description */
-			fscanf (ptr, "%d", &desc_len);
-			fgetc (ptr);	/* Read ONE newline */
+			(void) fscanf (ptr, "%d", &desc_len);
+			(void) fgetc (ptr);	/* Read ONE newline */
 			g_assert (desc_len < MAX_DESC_LEN);
 			/* Silly little hack follows */
-			tmpstr[0] = 0;
+			tmpstr[0] = (gchar)0;
 			do{
-				fgets (tmpstr + strlen(tmpstr), MAX_DESC_LEN -
-						strlen(tmpstr), ptr);
+				(void) fgets (tmpstr + strlen(tmpstr),
+					      MAX_DESC_LEN -
+					      strlen(tmpstr), ptr);
 			} while (strlen (tmpstr) - 1 < desc_len);
 			/* Overwrite the final newline with NULL. */
-			tmpstr[strlen (tmpstr) - 1] = 0;
-			g_assert (strlen (tmpstr) == desc_len);
-			g_string_assign (node_ptr -> description, tmpstr);
+			tmpstr = g_strchomp (tmpstr);
+			g_assert ((gint) strlen (tmpstr) == desc_len);
+			(void) g_string_assign (node_ptr -> description,
+						tmpstr);
 
 			/* Get the filename */
-			fgets (tmpstr, MAX_STR_LEN, ptr);
+			(void) fgets (tmpstr, MAX_STR_LEN, ptr);
 			/* Overwrite the final newline with NULL. */
-			tmpstr[strlen (tmpstr) - 1] = 0;
-			g_string_assign (node_ptr -> filename, tmpstr);
+			tmpstr = g_strchomp (tmpstr);
+			(void) g_string_assign (node_ptr -> filename,
+						tmpstr);
 
 			/* Read the trailing newline */
-			fscanf(ptr, "\n");
+			(void) fscanf(ptr, "\n");
 
 			kb_item = gtk_tree_item_new_with_label (node_ptr
 					-> name -> str);
-			gtk_object_set_data (GTK_OBJECT (kb_item), "node",
+			gtk_object_set_data (GTK_OBJECT (kb_item),
+					"node",
 					(gpointer)node_ptr);
 			gtk_tree_append (GTK_TREE (subtree), kb_item);
-			gtk_widget_show (kb_item);
-			gtk_signal_connect (GTK_OBJECT (kb_item),
-					"button_press_event",
-					GTK_SIGNAL_FUNC (on_tree_item_click),
-					NULL);
+			(void) gtk_signal_connect (GTK_OBJECT (kb_item),
+						   "button_press_event",
+						   GTK_SIGNAL_FUNC
+						   (on_tree_item_click),
+						   NULL);
 		} else if (indent == depth + 1) {
-			g_assert (kb_item);
+			debug_msg("reading child\n");
+			g_assert (kb_item != NULL);
 			new_subtree = gtk_tree_new ();
 			gtk_tree_item_set_subtree (GTK_TREE_ITEM (kb_item),
                                 new_subtree);
 			gtk_tree_item_expand (GTK_TREE_ITEM (kb_item));
-			gtk_widget_show (new_subtree);
 
 			ret = read_tree_items (indent, new_subtree, ptr);
 			if(ret < depth){
+				gtk_widget_show_all (subtree);
+				free (tmpstr);
 				return ret;
 			}
 		} else if (indent < depth) {
+			debug_msg("falling back\n");
+			gtk_widget_show_all (subtree);
+			free (tmpstr);
 			return indent;
 		} else {
 			/* What the fuck?!?!? */
+			g_error ("what the fuck?!?!?\n"
+"Please send a bug report to kibble@wish.student.harvard.edu\n");
 			g_assert (0);
 		}
 	}
+	gtk_widget_show_all (subtree);
+	free (tmpstr);
 	return -1;
 }
 
-void write_kbfile(void){
-	gchar kbfile[MAX_STR_LEN];
+void write_kbfile (void){
+	gchar *kbfile;
 	FILE *ptr;
 
-	/* Is it correct to weight by sizeof (gchar)? */
-	strncpy (kbfile, getenv("HOME"), sizeof (gchar) * (MAX_STR_LEN - 10));
-	strcat (kbfile, KBFILE);
+        kbfile = g_strconcat (g_get_home_dir (), KBFILE, NULL);
 
-	ptr = fopen(kbfile, "wt");
+	debug_msg ("writing %s\n" _ kbfile);
+	ptr = fopen (kbfile, "wt");
 	if(!ptr){
-		g_error("Could not open kb file %s for writing.", kbfile);
+		g_error ("Could not open kb file %s for writing.", kbfile);
 	}
 
 	write_node (ptr, tree_kb, 0);
-	fclose(ptr);
+	(void) fclose(ptr);
 }
 
 void write_node (FILE *ptr, GtkWidget *tree, gint indent){
@@ -186,6 +206,7 @@
 	node	*tree_node;
 
 	g_assert(indent < MAX_TREE_DEPTH);
+	debug_msg("writing tree item at depth %d\n" _ indent);
 	if(tree){
 		glistptr = GTK_TREE(tree)->children;
 		while(glistptr){
@@ -212,34 +233,40 @@
 void on_tree_item_click (GtkObject *tree_item, GdkEventButton *event,
 		gpointer func_data)
 {
-	g_assert (GTK_IS_TREE_ITEM(tree_item));
-	current_tree_item = tree_item;
+        debug_msg("tree item 0x%x clicked\n" _ (gint)tree_item);
 
 	if (event->type==GDK_2BUTTON_PRESS && event->button==1){
-		/* I might get screwed up if it starts actually using
-		 * the data */
+		debug_msg("left button double click\n");
+		/* A strange little hack. */
+		gtk_tree_select_child (GTK_TREE (tree_kb), GTK_WIDGET
+				(tree_item));
 		on_view_activate(NULL, NULL);
+		gtk_tree_select_child (GTK_TREE (tree_kb), GTK_WIDGET
+				(tree_item));
 	}
 }
 
 node *new_node (void)
 {
 	node *node_ptr;
-	node_ptr = g_malloc (sizeof (node));
+
+	node_ptr = g_malloc ((gulong) sizeof (node));
+	debug_msg("creating new node 0x%x\n" _ (gint)node_ptr);
+	if (node_ptr != NULL) {
+		node_ptr -> name	= g_string_new ("");
+		node_ptr -> description	= g_string_new ("");
+		node_ptr -> filename	= g_string_new ("");
+	} else { g_assert (node_ptr != NULL); }
 	/* If we have this little memory, we're fucked anyhow */
-	g_assert (node_ptr);
-	node_ptr -> name	= g_string_new ("");
-	node_ptr -> description	= g_string_new ("");
-	node_ptr -> filename	= g_string_new ("");
 
 	return (node_ptr);
 }
 
 void free_node (node *node_ptr)
 {
-	/* What does g_string_free's 2nd arg do? */
-	/* g_string_free(node_ptr -> name);
-	 * g_string_free(node_ptr -> description);
-	 * g_string_free(node_ptr -> filename); */
+	/* What about "node_ptr -> name";
+	 * "node_ptr -> description";
+	 * "node_ptr -> filename"; */
+	debug_msg("freeing node 0x%x\n" _ (gint)node_ptr);
 	g_free(node_ptr);
 }
diff -d -u -r kibble/kb.h kibble-0.7.2/kb.h
--- kibble/kb.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/kb.h	Mon Mar  8 17:56:45 1999
@@ -1,5 +1,5 @@
 /* kb.h
- * $Id: kb.h,v 0.4 1998/12/03 20:47:22 joseph Exp $
+ * $Id: kb.h,v 0.6 1998/12/22 01:57:00 joseph Exp $
  */
 
 /* kibble
@@ -25,24 +25,28 @@
 				 * (e.g. filenames */
 #define MAX_DESC_LEN	4096	/* Maximum length of descriptions */
 
-#define DATA(str, dlg) (gtk_object_get_data (GTK_OBJECT (dlg), str))
-#define TEXT_DATA(str, dlg) (gtk_entry_get_text (GTK_ENTRY (DATA (str, dlg))))
+#define DATA(str, dlg)		(gtk_object_get_data (GTK_OBJECT (dlg), str))
+#define TEXT_DATA(str, dlg)	(gtk_entry_get_text (GTK_ENTRY (DATA \
+				(str, dlg))))
+#define KB_ITEM_SELECTED	(GTK_TREE(tree_kb)->selection->data)
 
-typedef struct{
+struct _node {
 	GString *name;
 	GString *description;
 	GString *filename;
-} node;
+};
+
+typedef struct _node node;
 
 /* Stores the actual KB. Woo hoo, global! */
 extern GtkWidget *tree_kb;
-extern GtkObject *current_tree_item;	/* Currently selected item */
 
-void new_root_node	(void);
-void read_kbfile	(void);
-gint read_tree_items	(gint indent, GtkWidget *subtree, FILE *ptr);
-void write_kbfile	(void);
-void write_node		(FILE *ptr, GtkWidget *tree, gint indent);
-void on_tree_item_click (GtkObject *tree_item, GdkEventButton *event, gpointer func_data);
-node *new_node		(void);
-void free_node		(node *);
+extern void new_root_node	(void);
+extern void read_kbfile		(void);
+extern gint read_tree_items	(gint indent, GtkWidget *subtree, FILE *ptr);
+extern void write_kbfile	(void);
+extern void write_node		(FILE *ptr, GtkWidget *tree, gint indent);
+extern void on_tree_item_click (GtkObject *tree_item, GdkEventButton *event,
+		gpointer func_data);
+extern node *new_node		(void);
+extern void free_node		(node *);
diff -d -u -r kibble/main.c kibble-0.7.2/main.c
--- kibble/main.c	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/main.c	Mon Mar  8 17:56:44 1999
@@ -1,5 +1,5 @@
 /* main.c
- * $Id: main.c,v 0.15 1998/12/07 17:08:01 joseph Exp $
+ * $Id: main.c,v 0.20 1999/02/05 05:49:39 joseph Exp $
  */
 
 /* kibble
@@ -22,8 +22,59 @@
 
 #include "all.h"
 
+void not_implemented (void)
+{
+        /* Code idea borrowed from Glade */
+        /* I hope the translations don't overflow the buffer! */
+        gchar buf[1024];
+	debug_msg ("not implemented\n");
+        g_snprintf (buf, MAX_STR_LEN, ("Feature not yet implemented\n"
+			"Check http://wish.student.harvard.edu/kibble/\n"
+			"for a potentially newer version\n"
+			"or read the FAQ for help:\n"
+			"http://wish.student.harvard.edu/kibble/faq/"));
+        show_message_box (buf);
+}
+
+/*
+ * Shows a simple message box with a label and an 'OK' button.
+ * e.g. show_message_box ("Error saving file");
+ * Code taken from Glade's util.c
+ */
+void show_message_box (gchar *message)
+{
+	GtkWidget *dialog, *label, *button_okay;
+
+	dialog = gtk_dialog_new ();
+	debug_msg ("message box = 0x%x\n" _ (gint)dialog);
+	gtk_window_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
+	gtk_container_border_width (GTK_CONTAINER (dialog), 5);
+
+	label = gtk_label_new (message);
+	/* gtk_misc_set_padding (GTK_MISC (label), 20, 20); */
+	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), label,
+			TRUE, TRUE, 0);
+
+	button_okay = gtk_button_new_with_label ("Okay");
+	gtk_widget_set_usize (button_okay, 80, -1);
+	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), button_okay,
+			FALSE, FALSE, 14);
+	GTK_WIDGET_SET_FLAGS (button_okay, GTK_CAN_DEFAULT);
+	/* Added this focus line */
+        gtk_widget_grab_focus (button_okay);
+	gtk_widget_grab_default (button_okay);
+
+	(void) gtk_signal_connect_object (GTK_OBJECT (button_okay),
+					  "clicked", GTK_SIGNAL_FUNC
+					  (gtk_object_destroy), GTK_OBJECT
+					  (dialog));
+
+	gtk_widget_show_all (dialog);
+}
+
 void destroy_program (GtkMenuItem *menuitem, gpointer user_data)
 {
+	debug_msg ("destroy_program called\n");
 	/* Write unsaved data */
 	write_kbfile();
 
@@ -35,20 +86,20 @@
 int main (int argc, char *argv[])
 {
 	GtkWidget	*window_main;
-	gchar		rcfile[MAX_STR_LEN];
 
+#ifdef DEBUG
+	debug_msg ("Locale = %s\n" _ gtk_set_locale ());
+#else
 	gtk_set_locale ();
+#endif
+
 	gtk_init (&argc, &argv);
 
-	/* Source ~/.gtkrc */
-	/* (What about ~/gtkrc, /usr/local/share/themes/Default/gtk/gtkrc?) */
-        strncpy (rcfile, getenv("HOME"), sizeof(gchar) * (MAX_STR_LEN - 10));
-        strcat (rcfile, "/.gtkrc");
-	gtk_rc_parse (rcfile);
+	window_main		= create_window_main ();
+	debug_msg ("window_main = 0x%x\n" _ (gint)window_main);
 
-	window_main = create_window_main ();
-	gtk_widget_show (window_main);
 	read_kbfile ();
+	gtk_widget_show_all (window_main);
 
 	gtk_main ();
 	return 0;
diff -d -u -r kibble/main.h kibble-0.7.2/main.h
--- kibble/main.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/main.h	Mon Mar  8 17:56:45 1999
@@ -1,5 +1,5 @@
 /* main.h
- * $Id: main.h,v 0.10 1998/12/01 02:42:49 joseph Exp $
+ * $Id: main.h,v 0.13 1999/02/05 01:57:57 joseph Exp $
  */
 
 /* kibble
@@ -20,7 +20,17 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */
 
+/* Print out a debugging message */
+#ifdef DEBUG
+#define debug_msg(args) (g_print("file %s: line %d: ", __FILE__, __LINE__), g_print(args))
+#define _ ,
+#else
+#define debug_msg(args) ;
+#endif
+
 /* Opened in the user's home directory */
-#define KBFILE	"/.kibble_kb"
+#define KBFILE	g_string (/.kibble_kb)
 
-void destroy_program		(GtkMenuItem *menuitem, gpointer user_data);
+extern void not_implemented	(void);
+extern void show_message_box	(gchar *message);
+extern void destroy_program	(GtkMenuItem *menuitem, gpointer user_data);
diff -d -u -r kibble/main_menu.c kibble-0.7.2/main_menu.c
--- kibble/main_menu.c	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/main_menu.c	Mon Mar  8 17:56:44 1999
@@ -1,5 +1,5 @@
 /* main_menu.c
- * $Id: main_menu.c,v 0.15 1998/12/05 02:55:56 joseph Exp $
+ * $Id: main_menu.c,v 0.19 1999/02/05 01:57:57 joseph Exp $
  */
 
 /* kibble
@@ -24,76 +24,69 @@
 
 void on_save_activate (GtkMenuItem *menuitem, gpointer user_data)
 {
+        debug_msg("saving kb\n");
 	write_kbfile();
-	MODAL(
 	show_message_box ("Save completed\nsuccessfully.\n");
-	     )
 }
 
 void on_add_activate (GtkMenuItem *menuitem, gpointer user_data)
 {
 	/* Grab tree data, display error message if none selected */
-	GtkWidget *dialog_add;
-
-
+        debug_msg("add activated\n");
 	/* If no tree item is currently selected */
-	if(!current_tree_item){
-		MODAL(
+	if((tree_kb == NULL || GTK_TREE(tree_kb)->selection == NULL) ||
+			KB_ITEM_SELECTED == NULL){
+		debug_msg("no tree item selected\n");
 		show_message_box("No tree item is\ncurrently selected\n");
-		     )
 	} else {
-		MODAL(
-		dialog_add = create_dialog_add ();
-		gtk_widget_show (dialog_add);
-		     )
+		debug_msg("parent tree item = 0x%x\n" _
+				(gint)KB_ITEM_SELECTED);
+		create_dialog_add ();
 	}
 }
 
 void on_view_activate (GtkMenuItem *menuitem, gpointer user_data)
 {
 	/* Grab tree data, display error message if none selected */
-	GtkWidget *dialog_view;
-
+        debug_msg("view activated\n");
 	/* If no tree item is currently selected */
-	if(!current_tree_item){
-		MODAL(
+	if((tree_kb == NULL || GTK_TREE(tree_kb)->selection == NULL) ||
+			KB_ITEM_SELECTED == NULL){
+		debug_msg("no tree item selected\n");
 		show_message_box("No tree item is\ncurrently selected\n");
-		     )
 	} else {
-		MODAL(
-		dialog_view = create_dialog_view ();
-		gtk_widget_show (dialog_view);
-		     )
+		debug_msg("tree item = 0x%x\n" _
+				(gint)KB_ITEM_SELECTED);
+		create_dialog_view ();
 	}
 }
 
 void on_delete_activate (GtkMenuItem *menuitem, gpointer user_data)
 {
 	/* Grab tree data, display error message if none selected */
-	GtkWidget *dialog_delete;
-
-
+        debug_msg("delete activated\n");
 	/* If no tree item is currently selected */
-	if(!current_tree_item){
-		MODAL(
+	if((tree_kb == NULL || GTK_TREE(tree_kb)->selection == NULL) ||
+			KB_ITEM_SELECTED == NULL){
+		debug_msg("no tree item selected\n");
 		show_message_box("No tree item is\ncurrently selected\n");
-		     )
 	} else {
-		MODAL(
-		dialog_delete = create_dialog_delete ();
-		gtk_widget_show (dialog_delete);
-		     )
+		debug_msg("tree item = 0x%x\n" _
+				(gint)KB_ITEM_SELECTED);
+		create_dialog_delete ();
 	}
 }
 
 void on_contents_activate (GtkMenuItem *menuitem, gpointer user_data)
 {
-        modal_not_implemented();
+        debug_msg("contents activated\n");
+        not_implemented();
 }
 
 void on_index_activate (GtkMenuItem *menuitem, gpointer user_data)
 {
-        modal_not_implemented();
+        debug_msg("index activated\n");
+        not_implemented();
 }
 
 void on_about_activate (GtkMenuItem *menuitem, gpointer user_data)
@@ -101,166 +94,86 @@
 	/* Code idea borrowed from Glade */
 	/* I hope the translations don't overflow the buffer! */
 	gchar buf[1024];
-	/* VERSION comes from configure.in -
-	 * the only place it should be defined */
-	sprintf (buf, ("Kibble\n\n"
+
+        debug_msg("about activated\n");
+	g_snprintf (buf, MAX_STR_LEN,
+			("Kibble\n\n"
 			"A Knowledge Base program.\n\n"
 			"Version %s\n\n"
 			"By Joseph P. Turian\n\n"
 			"Email: kibble@wish.student.harvard.edu\n"
 			"Web: http://wish.student.harvard.edu/kibble/\n"),
 			VERSION);
-	MODAL(
 	show_message_box (buf);
-	)
 }
 
 #ifdef GTK_HAVE_FEATURES_1_1_0
-void create_menu_main (GtkWidget *window_main, GtkWidget *vbox)
+/* How the hell do I do F1 in this? */
+#define GMC	(GtkItemFactoryCallback)
+#define ON	0, NULL
+static GtkItemFactoryEntry menu_items[] =
 {
-	GtkWidget *menu_bar;
-	GtkWidget *menu;
-	GtkWidget *menu_item;
-	GtkAccelGroup *accel_group;
-
-	/* This code should be with the main_window code */
-	accel_group = gtk_accel_group_new ();
-	gtk_window_add_accel_group (GTK_WINDOW (window_main), accel_group);
-
-	menu_bar = gtk_menu_bar_new ();
-	gtk_widget_show (menu_bar);
-	// Unneccessary, yes?
-	// gtk_object_set_data (GTK_OBJECT (window_main), "menu_bar", menu_bar);
-	gtk_box_pack_start (GTK_BOX (vbox), menu_bar, FALSE, FALSE, 0);
-
-	menu_item = gtk_menu_item_new_with_label ("File");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu_bar), menu_item);
-
-	menu = gtk_menu_new ();
-	gtk_widget_show (menu);
-	gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), menu);
-
-	menu_item = gtk_menu_item_new_with_label ("Save");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
-	gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
-			GTK_SIGNAL_FUNC (on_save_activate),
-			NULL);
-	gtk_widget_add_accelerator (menu_item, "activate", accel_group,
-			GDK_s, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
-
-	menu_item = gtk_menu_item_new ();
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
-
-	menu_item = gtk_menu_item_new_with_label ("Quit");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
-	gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
-			GTK_SIGNAL_FUNC (destroy_program),
-			NULL);
-	gtk_widget_add_accelerator (menu_item, "activate", accel_group,
-			GDK_q, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
-
-	menu_item = gtk_menu_item_new_with_label ("Edit");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu_bar), menu_item);
-
-	menu = gtk_menu_new ();
-	gtk_widget_show (menu);
-	gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), menu);
-
-	menu_item = gtk_menu_item_new_with_label ("Add");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
-	gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
-			GTK_SIGNAL_FUNC (on_add_activate),
-			NULL);
-	gtk_widget_add_accelerator (menu_item, "activate", accel_group,
-			GDK_a, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
-
-	menu_item = gtk_menu_item_new_with_label ("View");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
-	gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
-			GTK_SIGNAL_FUNC (on_view_activate),
-			NULL);
-	gtk_widget_add_accelerator (menu_item, "activate", accel_group,
-			GDK_v, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
-
-	menu_item = gtk_menu_item_new_with_label ("Delete");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
-	gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
-			GTK_SIGNAL_FUNC (on_delete_activate),
-			NULL);
-	gtk_widget_add_accelerator (menu_item, "activate", accel_group,
-			GDK_d, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
+	{"/_File",		NULL,		NULL,	0, "<Branch>"},
+	{"/File/_Save",		"<control>S",	GMC on_save_activate,	ON},
+	{"/File/sep1",		NULL,		NULL,	0, "<Separator>"},
+	{"/File/_Quit",		"<control>Q",	GMC destroy_program,	ON},
+	{"/_Edit",		NULL,		NULL,	0, "<Branch>"},
+	{"/Edit/_Add",		"<control>A",	GMC on_add_activate,	ON},
+	{"/Edit/_View",		"<control>V",	GMC on_view_activate,	ON},
+	{"/Edit/_Delete",	"<control>D",	GMC on_delete_activate,	ON},
+	{"/_Help",		NULL,		NULL,	0, "<LastBranch>"},
+	{"/Help/_Contents",	NULL,		GMC on_contents_activate, ON},
+	{"/Help/_Index",	NULL,		GMC on_index_activate,	ON},
+	{"/Help/sep2",		NULL,		NULL,	0, "<Separator>"},
+	{"/Help/_About...",	NULL,		GMC on_about_activate,	ON},
+};
 
-	menu_item = gtk_menu_item_new_with_label ("Help");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu_bar), menu_item);
-	gtk_menu_item_right_justify (GTK_MENU_ITEM (menu_item));
+void create_menu_main (GtkWidget *window_main, GtkWidget *vbox)
+{
+	guint		nmenu_items = (guint) (sizeof (menu_items) /
+			sizeof (menu_items[0]));
+	GtkAccelGroup	*accel_group;
+	GtkItemFactory	*factory;
 
-	menu = gtk_menu_new ();
-	gtk_widget_show (menu);
-	gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_item), menu);
 
-	menu_item = gtk_menu_item_new_with_label ("Contents");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
-	gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
-			GTK_SIGNAL_FUNC (on_contents_activate),
-			NULL);
-	gtk_widget_add_accelerator (menu_item, "activate", accel_group,
-			GDK_F1, 0, GTK_ACCEL_VISIBLE);
+	debug_msg("creating 1.1.x main menu with item_factory\n");
 
-	menu_item = gtk_menu_item_new_with_label ("Index");
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
-	gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
-			GTK_SIGNAL_FUNC (on_index_activate),
+	accel_group = gtk_accel_group_new ();
+	factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<Main>",
+			accel_group);
+	gtk_item_factory_create_items (factory, nmenu_items, menu_items,
 			NULL);
-	gtk_widget_add_accelerator (menu_item, "activate", accel_group,
-			GDK_F1, GDK_SHIFT_MASK, GTK_ACCEL_VISIBLE);
+	gtk_accel_group_attach (accel_group, GTK_OBJECT (window_main));
 
-	menu_item = gtk_menu_item_new ();
-	gtk_widget_show (menu_item);
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
+	gtk_box_pack_start (GTK_BOX (vbox),  gtk_item_factory_get_widget
+			(factory, "<Main>"), FALSE, FALSE, 0);
 
-	menu_item = gtk_menu_item_new_with_label ("About...");
-	gtk_container_add (GTK_CONTAINER (menu), menu_item);
-	gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
-			GTK_SIGNAL_FUNC (on_about_activate),
-			NULL);
-	gtk_widget_add_accelerator (menu_item, "activate", accel_group,
-			GDK_F1, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
-	gtk_widget_show (menu_item);
+	gtk_widget_show (gtk_item_factory_get_widget (factory, "<Main>"));
 }
+
 #else
 
 /* GtkMenuFactory is deprecated. Figure out GtkItemFactory. */
 /* How the hell do I do F1 in this? */
 static GtkMenuEntry menu_items[] =
 {
-	{"<Main>/File/Save",    "<control>S",
+	{"/File/Save",    "<control>S",
 		(GtkMenuCallback)on_save_activate, NULL},
-	{"<Main>/File/<separator>", NULL,	NULL, NULL},
-	{"<Main>/File/Quit",    "<control>Q",
+	{"/File/<separator>", NULL,	NULL, NULL},
+	{"/File/Quit",    "<control>Q",
 		(GtkMenuCallback)destroy_program, NULL},
-	{"<Main>/Edit/Add",     "<control>A",
+	{"/Edit/Add",     "<control>A",
 		(GtkMenuCallback)on_add_activate, NULL},
-	{"<Main>/Edit/View",    "<control>V",
+	{"/Edit/View",    "<control>V",
 		(GtkMenuCallback)on_view_activate, NULL},
-	{"<Main>/Edit/Delete",  "<control>D",
+	{"/Edit/Delete",  "<control>D",
 		(GtkMenuCallback)on_delete_activate, NULL},
-	{"<Main>/Help/Contents", NULL,
+	{"/Help/Contents", NULL,
 		(GtkMenuCallback)on_contents_activate, NULL},
-	{"<Main>/Help/Index",   NULL,
+	{"/Help/Index",   NULL,
 		(GtkMenuCallback)on_index_activate, NULL},
-	{"<Main>/Help/<separator>", NULL,	NULL, NULL},
-	{"<Main>/Help/About...", NULL,
+	{"/Help/<separator>", NULL,	NULL, NULL},
+	{"/Help/About...", NULL,
 		(GtkMenuCallback)on_about_activate, NULL},
 };
 
@@ -272,18 +185,19 @@
 	GtkMenuFactory	*subfactory;
 	GtkMenuPath	*menu_path;
 
+        debug_msg("creating 1.0.x main menu with menu_factory\n");
 	factory = gtk_menu_factory_new (GTK_MENU_FACTORY_MENU_BAR);
 	subfactory = gtk_menu_factory_new (GTK_MENU_FACTORY_MENU_BAR);
 
-	gtk_menu_factory_add_subfactory (factory, subfactory, "<Main>");
+	gtk_menu_factory_add_subfactory (factory, subfactory, "");
 	gtk_menu_factory_add_entries (factory, menu_items, nmenu_items);
 	gtk_window_add_accelerator_table (GTK_WINDOW (window_main),
 			subfactory->table);
 
-	menu_path = gtk_menu_factory_find (factory, "<Main>/Help");
+	menu_path = gtk_menu_factory_find (factory, "/Help");
 	gtk_menu_item_right_justify (GTK_MENU_ITEM (menu_path->widget));
 
-	g_assert (GTK_MENU_BAR (subfactory->widget));
+	g_assert (GTK_MENU_BAR (subfactory->widget) != NULL);
 	gtk_box_pack_start (GTK_BOX (vbox), subfactory->widget, FALSE,
 			FALSE, 0);
 	gtk_widget_show (subfactory->widget);
diff -d -u -r kibble/main_menu.h kibble-0.7.2/main_menu.h
--- kibble/main_menu.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/main_menu.h	Mon Mar  8 17:56:45 1999
@@ -1,5 +1,5 @@
 /* main_menu.h
- * $Id: main_menu.h,v 0.2 1998/11/17 08:12:31 joseph Exp $
+ * $Id: main_menu.h,v 0.3 1998/12/21 04:23:33 joseph Exp $
  */
 
 /* kibble
@@ -20,15 +20,15 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */
 
-void on_new_activate		(GtkMenuItem *menuitem, gpointer user_data);
-void on_open_activate		(GtkMenuItem *menuitem, gpointer user_data);
-void on_save_activate		(GtkMenuItem *menuitem, gpointer user_data);
-void on_save_as_activate	(GtkMenuItem *menuitem, gpointer user_data);
-void on_add_activate		(GtkMenuItem *menuitem, gpointer user_data);
-void on_view_activate		(GtkMenuItem *menuitem, gpointer user_data);
-void on_delete_activate		(GtkMenuItem *menuitem, gpointer user_data);
-void on_contents_activate	(GtkMenuItem *menuitem, gpointer user_data);
-void on_index_activate		(GtkMenuItem *menuitem, gpointer user_data);
-void on_about_activate		(GtkMenuItem *menuitem, gpointer user_data);
+extern void on_new_activate	(GtkMenuItem *menuitem, gpointer user_data);
+extern void on_open_activate	(GtkMenuItem *menuitem, gpointer user_data);
+extern void on_save_activate	(GtkMenuItem *menuitem, gpointer user_data);
+extern void on_save_as_activate	(GtkMenuItem *menuitem, gpointer user_data);
+extern void on_add_activate	(GtkMenuItem *menuitem, gpointer user_data);
+extern void on_view_activate	(GtkMenuItem *menuitem, gpointer user_data);
+extern void on_delete_activate	(GtkMenuItem *menuitem, gpointer user_data);
+extern void on_contents_activate (GtkMenuItem *menuitem, gpointer user_data);
+extern void on_index_activate	(GtkMenuItem *menuitem, gpointer user_data);
+extern void on_about_activate	(GtkMenuItem *menuitem, gpointer user_data);
 
-void create_menu_main (GtkWidget *, GtkWidget *);
+extern void create_menu_main	(GtkWidget *, GtkWidget *);
diff -d -u -r kibble/main_window.c kibble-0.7.2/main_window.c
--- kibble/main_window.c	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/main_window.c	Mon Mar  8 17:56:44 1999
@@ -1,5 +1,5 @@
 /* main_window.c
- * $Id: main_window.c,v 0.10 1998/12/07 02:42:53 joseph Exp $
+ * $Id: main_window.c,v 0.14 1999/03/08 22:26:14 joseph Exp $
  */
 
 /* kibble
@@ -29,38 +29,43 @@
 	GtkWidget *scrolledwindow;
 
 	window_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
+	debug_msg ("window_main = 0x%x created\n" _ (gint)window_main);
 	gtk_window_set_title (GTK_WINDOW (window_main), "Kibble");
 	gtk_window_position (GTK_WINDOW (window_main), GTK_WIN_POS_CENTER);
 	gtk_window_set_policy (GTK_WINDOW (window_main), TRUE, TRUE, TRUE);
-	gtk_widget_set_usize (GTK_WIDGET (window_main), 200, 200);
-        gtk_signal_connect (GTK_OBJECT (window_main), "destroy",
-                        GTK_SIGNAL_FUNC (destroy_program), NULL);
+	gtk_widget_set_usize (GTK_WIDGET (window_main), 300, 300);
+        (void) gtk_signal_connect (GTK_OBJECT (window_main), "destroy",
+				   GTK_SIGNAL_FUNC (destroy_program), NULL);
 
 	vbox = gtk_vbox_new (FALSE, 0);
-	gtk_widget_show (vbox);
 	gtk_container_add (GTK_CONTAINER (window_main), vbox);
 
 	create_menu_main (window_main, vbox);
 
 	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
-#ifdef GTK_HAVE_FEATURES_1_1_0
-	/* Grrr... this should work with GTK 1.0.x, I don't know why it
+	/* Grrr... this should work with GTK 1.[02].x, I don't know why it
 	 * keeps snapping back to the original size. */
+	/* debug_msg ("scrolled_policy = automatic\n");
 	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow),
-			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
-#endif
+			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC); */
+	debug_msg ("SCROLLED_POLICY =/= AUTOMATIC\n");
 	gtk_box_pack_start (GTK_BOX (vbox), scrolledwindow, TRUE, TRUE, 10);
 
 	tree_kb = gtk_tree_new ();
-	gtk_widget_show (tree_kb);
+	if (tree_kb == NULL) {
+		g_assert (0);
+		return NULL;
+	}
 	/* Check for CVS/very new GTK+ code */
 #ifdef HAVE_GTK_SCROLLED_WINDOW_ADD_WITH_VIEWPORT
+	debug_msg ("have gtk_scrolled_window_add_with_viewport\n");
 	gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW
 			(scrolledwindow), tree_kb);
 #else
+	debug_msg ("don't have gtk_scrolled_window_add_with_viewport\n"
+			"(using gtk_container_add"\n));
 	gtk_container_add (GTK_CONTAINER (scrolledwindow), tree_kb);
 #endif
-	gtk_widget_show (scrolledwindow);
 	gtk_container_border_width (GTK_CONTAINER (tree_kb), 10);
 	GTK_WIDGET_SET_FLAGS (tree_kb, GTK_CAN_FOCUS);
 	GTK_WIDGET_SET_FLAGS (tree_kb, GTK_CAN_DEFAULT);
